/*     */ package org.hibernate.cfg.annotations;
/*     */ 
/*     */ import java.util.Map;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.hibernate.AnnotationException;
/*     */ import org.hibernate.MappingException;
/*     */ import org.hibernate.annotations.OrderBy;
/*     */ import org.hibernate.annotations.Sort;
/*     */ import org.hibernate.annotations.common.reflection.XClass;
/*     */ import org.hibernate.annotations.common.reflection.XProperty;
/*     */ import org.hibernate.cfg.CollectionSecondPass;
/*     */ import org.hibernate.cfg.Ejb3Column;
/*     */ import org.hibernate.cfg.Ejb3JoinColumn;
/*     */ import org.hibernate.cfg.ExtendedMappings;
/*     */ import org.hibernate.cfg.IndexColumn;
/*     */ import org.hibernate.cfg.Mappings;
/*     */ import org.hibernate.cfg.PropertyHolder;
/*     */ import org.hibernate.cfg.PropertyHolderBuilder;
/*     */ import org.hibernate.cfg.SecondPass;
/*     */ import org.hibernate.mapping.Collection;
/*     */ import org.hibernate.mapping.IndexBackref;
/*     */ import org.hibernate.mapping.KeyValue;
/*     */ import org.hibernate.mapping.List;
/*     */ import org.hibernate.mapping.OneToMany;
/*     */ import org.hibernate.mapping.PersistentClass;
/*     */ import org.hibernate.mapping.SimpleValue;
/*     */ import org.hibernate.util.StringHelper;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ListBinder
/*     */   extends CollectionBinder
/*     */ {
/*  35 */   private static Log log = LogFactory.getLog(ListBinder.class);
/*     */   
/*     */ 
/*     */ 
/*     */   protected Collection createCollection(PersistentClass persistentClass)
/*     */   {
/*  41 */     return new List(persistentClass);
/*     */   }
/*     */   
/*     */   public void setSqlOrderBy(OrderBy orderByAnn) {
/*  45 */     if (orderByAnn != null) log.warn("@OrderBy not allowed for a indexed collection, annotation ignored.");
/*     */   }
/*     */   
/*     */   public void setSort(Sort sortAnn) {
/*  49 */     if (sortAnn != null) { log.warn("@Sort not allowed for a indexed collection, annotation ignored.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SecondPass getSecondPass(final Ejb3JoinColumn[] fkJoinColumns, final Ejb3JoinColumn[] keyColumns, final Ejb3JoinColumn[] inverseColumns, final Ejb3Column[] elementColumns, Ejb3Column[] mapKeyColumns, Ejb3JoinColumn[] mapKeyManyToManyColumns, final boolean isEmbedded, final XProperty property, final XClass collType, final boolean ignoreNotFound, final boolean unique, final TableBinder assocTableBinder, final ExtendedMappings mappings)
/*     */   {
/*  62 */     new CollectionSecondPass(mappings, this.collection)
/*     */     {
/*     */       public void secondPass(Map persistentClasses, Map inheritedMetas) throws MappingException {
/*  65 */         ListBinder.this.bindStarToManySecondPass(persistentClasses, collType, fkJoinColumns, keyColumns, inverseColumns, elementColumns, isEmbedded, property, unique, assocTableBinder, ignoreNotFound, mappings);
/*     */         
/*     */ 
/*     */ 
/*  69 */         ListBinder.this.bindIndex(mappings);
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   private void bindIndex(ExtendedMappings mappings) {
/*  75 */     if (!this.indexColumn.isImplicit()) {
/*  76 */       PropertyHolder valueHolder = PropertyHolderBuilder.buildPropertyHolder(this.collection, StringHelper.qualify(this.collection.getRole(), "key"), (XClass)null, (XProperty)null, this.propertyHolder, mappings);
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  82 */       List list = (List)this.collection;
/*  83 */       if (!list.isOneToMany()) this.indexColumn.forceNotNull();
/*  84 */       this.indexColumn.setPropertyHolder(valueHolder);
/*  85 */       SimpleValueBinder value = new SimpleValueBinder();
/*  86 */       value.setColumns(new Ejb3Column[] { this.indexColumn });
/*  87 */       value.setExplicitType("integer");
/*  88 */       value.setMappings(mappings);
/*  89 */       SimpleValue indexValue = value.make();
/*  90 */       this.indexColumn.linkWithValue(indexValue);
/*  91 */       list.setIndex(indexValue);
/*  92 */       list.setBaseIndex(this.indexColumn.getBase());
/*  93 */       if ((list.isOneToMany()) && (!list.getKey().isNullable()) && (!list.isInverse())) {
/*  94 */         String entityName = ((OneToMany)list.getElement()).getReferencedEntityName();
/*  95 */         PersistentClass referenced = mappings.getClass(entityName);
/*  96 */         IndexBackref ib = new IndexBackref();
/*  97 */         ib.setName('_' + this.propertyName + "IndexBackref");
/*  98 */         ib.setUpdateable(false);
/*  99 */         ib.setSelectable(false);
/* 100 */         ib.setCollectionRole(list.getRole());
/* 101 */         ib.setEntityName(list.getOwner().getEntityName());
/* 102 */         ib.setValue(list.getIndex());
/* 103 */         referenced.addProperty(ib);
/*     */       }
/*     */     }
/*     */     else {
/* 107 */       Collection coll = this.collection;
/* 108 */       throw new AnnotationException("List/array has to be annotated with an @IndexColumn: " + coll.getRole());
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\annotations\ListBinder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */