/*     */ package org.hibernate.ejb.packaging;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Properties;
/*     */ import java.util.Set;
/*     */ import javax.persistence.spi.PersistenceUnitTransactionType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class PersistenceMetadata
/*     */ {
/*     */   private String name;
/*     */   private String nonJtaDatasource;
/*     */   private String jtaDatasource;
/*     */   private String provider;
/*     */   private PersistenceUnitTransactionType transactionType;
/*  27 */   private List<String> classes = new ArrayList();
/*  28 */   private List<String> packages = new ArrayList();
/*  29 */   private List<String> mappingFiles = new ArrayList();
/*  30 */   private Set<String> jarFiles = new HashSet();
/*  31 */   private List<NamedInputStream> hbmfiles = new ArrayList();
/*  32 */   private Properties props = new Properties();
/*  33 */   private boolean excludeUnlistedClasses = false;
/*     */   
/*     */   public String getName() {
/*  36 */     return this.name;
/*     */   }
/*     */   
/*     */   public void setName(String name) {
/*  40 */     this.name = name;
/*     */   }
/*     */   
/*     */   public PersistenceUnitTransactionType getTransactionType() {
/*  44 */     return this.transactionType;
/*     */   }
/*     */   
/*     */   public void setTransactionType(PersistenceUnitTransactionType transactionType) {
/*  48 */     this.transactionType = transactionType;
/*     */   }
/*     */   
/*     */   public String getNonJtaDatasource() {
/*  52 */     return this.nonJtaDatasource;
/*     */   }
/*     */   
/*     */   public void setNonJtaDatasource(String nonJtaDatasource) {
/*  56 */     this.nonJtaDatasource = nonJtaDatasource;
/*     */   }
/*     */   
/*     */   public String getJtaDatasource() {
/*  60 */     return this.jtaDatasource;
/*     */   }
/*     */   
/*     */   public void setJtaDatasource(String jtaDatasource) {
/*  64 */     this.jtaDatasource = jtaDatasource;
/*     */   }
/*     */   
/*     */   public String getProvider() {
/*  68 */     return this.provider;
/*     */   }
/*     */   
/*     */   public void setProvider(String provider) {
/*  72 */     if ((provider != null) && (provider.endsWith(".class"))) {
/*  73 */       this.provider = provider.substring(0, provider.length() - 6);
/*     */     }
/*  75 */     this.provider = provider;
/*     */   }
/*     */   
/*     */   public List<String> getClasses() {
/*  79 */     return this.classes;
/*     */   }
/*     */   
/*     */   public void setClasses(List<String> classes) {
/*  83 */     this.classes = classes;
/*     */   }
/*     */   
/*     */   public List<String> getPackages() {
/*  87 */     return this.packages;
/*     */   }
/*     */   
/*     */   public void setPackages(List<String> packages) {
/*  91 */     this.packages = packages;
/*     */   }
/*     */   
/*     */   public List<String> getMappingFiles() {
/*  95 */     return this.mappingFiles;
/*     */   }
/*     */   
/*     */   public void setMappingFiles(List<String> mappingFiles) {
/*  99 */     this.mappingFiles = mappingFiles;
/*     */   }
/*     */   
/*     */   public Set<String> getJarFiles() {
/* 103 */     return this.jarFiles;
/*     */   }
/*     */   
/*     */   public void setJarFiles(Set<String> jarFiles) {
/* 107 */     this.jarFiles = jarFiles;
/*     */   }
/*     */   
/*     */   public Properties getProps() {
/* 111 */     return this.props;
/*     */   }
/*     */   
/*     */   public void setProps(Properties props) {
/* 115 */     this.props = props;
/*     */   }
/*     */   
/*     */   public List<NamedInputStream> getHbmfiles() {
/* 119 */     return this.hbmfiles;
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setHbmfiles(List<NamedInputStream> hbmfiles) {
/* 126 */     this.hbmfiles = hbmfiles;
/*     */   }
/*     */   
/*     */   public boolean getExcludeUnlistedClasses() {
/* 130 */     return this.excludeUnlistedClasses;
/*     */   }
/*     */   
/*     */   public void setExcludeUnlistedClasses(boolean excludeUnlistedClasses) {
/* 134 */     this.excludeUnlistedClasses = excludeUnlistedClasses;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/* 139 */     StringBuilder sb = new StringBuilder();
/* 140 */     sb.append("PersistenceMetadata [\n").append("\tname: ").append(this.name).append("\n").append("\tjtaDataSource: ").append(this.jtaDatasource).append("\n").append("\tnonJtaDataSource: ").append(this.nonJtaDatasource).append("\n").append("\ttransactionType: ").append(this.transactionType).append("\n").append("\tprovider: ").append(this.provider).append("\n").append("\tclasses[\n");
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 147 */     if (this.classes != null) {
/* 148 */       for (String elt : this.classes) {
/* 149 */         sb.append("\t\t").append(elt);
/*     */       }
/*     */     }
/* 152 */     sb.append("\t]\n").append("\tpackages[\n");
/*     */     
/* 154 */     if (this.packages != null) {
/* 155 */       for (String elt : this.packages) {
/* 156 */         sb.append("\t\t").append(elt).append("\n");
/*     */       }
/*     */     }
/* 159 */     sb.append("\t]\n").append("\tmappingFiles[\n");
/*     */     
/* 161 */     if (this.mappingFiles != null) {
/* 162 */       for (String elt : this.mappingFiles) {
/* 163 */         sb.append("\t\t").append(elt).append("\n");
/*     */       }
/*     */     }
/* 166 */     sb.append("\t]\n").append("\tjarFiles[\n");
/*     */     
/* 168 */     if (this.jarFiles != null) {
/* 169 */       for (String elt : this.jarFiles) {
/* 170 */         sb.append("\t\t").append(elt).append("\n");
/*     */       }
/*     */     }
/* 173 */     sb.append("\t]\n").append("\thbmfiles: ").append(this.hbmfiles != null ? this.hbmfiles.size() : 0).append("\n").append("\tproperties[\n");
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 178 */     if (this.props != null) {
/* 179 */       for (Map.Entry elt : this.props.entrySet()) {
/* 180 */         sb.append("\t\t").append(elt.getKey()).append(": ").append(elt.getValue()).append("\n");
/*     */       }
/*     */     }
/* 183 */     sb.append("\t]").append("]");
/*     */     
/* 185 */     return sb.toString();
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-entitymanager-3.3.2.GA.jar!\org\hibernate\ejb\packaging\PersistenceMetadata.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */